darcs-2.8.4: a distributed, interactive, smart revision control system

Safe Haskell | None

Darcs.Patch.Set

Synopsis

- data PatchSet p start y where
  - PatchSet :: RL (PatchInfoAnd p) x y -> RL (Tagged p) start x -> PatchSet p start y
- data Tagged p x z where
  - Tagged :: PatchInfoAnd p y z -> Maybe String -> RL (PatchInfoAnd p) x y -> Tagged p x z
- type SealedPatchSet p start = Sealed (PatchSet p start)
- data Origin
- progressPatchSet :: String -> PatchSet p start x -> PatchSet p start x
- tags :: PatchSet p start x -> [PatchInfo]
- appendPSFL :: PatchSet p start x -> FL (PatchInfoAnd p) x y -> PatchSet p start y
- newset2RL :: PatchSet p start x -> RL (PatchInfoAnd p) start x
- newset2FL :: PatchSet p start x -> FL (PatchInfoAnd p) start x

# Documentation

data PatchSet p start y where

Constructors

PatchSet :: RL (PatchInfoAnd p) x y -> RL (Tagged p) start x -> PatchSet p start y |

data Tagged p x z where

Constructors

Tagged :: PatchInfoAnd p y z -> Maybe String -> RL (PatchInfoAnd p) x y -> Tagged p x z |

type SealedPatchSet p start = Sealed (PatchSet p start)

data Origin

progressPatchSet :: String -> PatchSet p start x -> PatchSet p start x

Runs a progress action for each tag and patch in a given PatchSet, using the passed progress message. Does not alter the PatchSet.

tags :: PatchSet p start x -> [PatchInfo]

tags returns the PatchInfos corresponding to the tags of a given PatchSet.

appendPSFL :: PatchSet p start x -> FL (PatchInfoAnd p) x y -> PatchSet p start y

appendPSFL takes a PatchSet and a FL of patches that `follow` the PatchSet, and concatenates the patches into the PatchSet.

newset2RL :: PatchSet p start x -> RL (PatchInfoAnd p) start x

newset2RL takes a PatchSet and returns an equivalent, linear RL of patches.

newset2FL :: PatchSet p start x -> FL (PatchInfoAnd p) start x

newset2FL takes a PatchSet and returns an equivalent, linear FL of patches.